> This page is for API Reference.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://okx-demo.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://okx-demo.ferndocs.com/_mcp/server.

# Get historical market data

GET https://www.okx.com/api/v5/public/market-data-history

Retrieve downloadable historical market-data file groups (trades, candles, funding rate, order book, borrowing rate) for the requested instruments and date range.

Reference: https://okx-demo.ferndocs.com/api/api-reference/public-data/get-market-data-history

## Request

### Query parameters

- `module` (string, required) — Data module: 1 (trades), 2 (1m candles), 3 (funding rate), 4 (400-level order book), 5 (5000-level order book), 6 (50-level order book), 11 (borrowing rate).
- `instType` (enum, required) — Instrument type.
  - Allowed values: `SPOT`, `FUTURES`, `SWAP`, `OPTION`
- `instIdList` (string, optional) — List of instrument IDs, e.g. BTC-USDT. Either instIdList or instFamilyList is required.
- `instFamilyList` (string, optional) — List of instrument families, e.g. BTC-USD. Either instIdList or instFamilyList is required.
- `dateAggrType` (enum, required) — Date aggregation type of the returned file groups.
  - Allowed values: `daily`, `monthly`
- `begin` (string, required) — Start date, Unix timestamp in milliseconds.
- `end` (string, required) — End date, Unix timestamp in milliseconds.

## Response

### 200

Successful response

- `code` (string, optional) — Result code. `0` means success; any other value is an error code.
- `msg` (string, optional) — Error message. Empty on success.
- `data` (list of ApiV5PublicMarketDataHistoryGetResponsesContentApplicationJsonSchemaDataItems, optional)

## Types

### ApiV5PublicMarketDataHistoryGetResponsesContentApplicationJsonSchemaDataItems

- `dateAggrType` (string, optional) — Date aggregation type: daily or monthly.
- `totalSizeMB` (string, optional) — Total size of all matching files in MB.
- `ts` (string, optional) — Data return time, Unix timestamp in milliseconds.
- `details` (list of ApiV5PublicMarketDataHistoryGetResponsesContentApplicationJsonSchemaDataItemsDetailsItems, optional) — File groups by instrument.

### ApiV5PublicMarketDataHistoryGetResponsesContentApplicationJsonSchemaDataItemsDetailsItems

- `instId` (string, optional) — Instrument ID.
- `instFamily` (string, optional) — Instrument family.
- `instType` (string, optional) — Instrument type.
- `dateRangeStart` (string, optional) — Start of the covered date range, Unix timestamp in milliseconds.
- `dateRangeEnd` (string, optional) — End of the covered date range, Unix timestamp in milliseconds.
- `groupSizeMB` (string, optional) — Size of this instrument's file group in MB.
- `groupDetails` (list of ApiV5PublicMarketDataHistoryGetResponsesContentApplicationJsonSchemaDataItemsDetailsItemsGroupDetailsItems, optional) — Individual downloadable files.

### ApiV5PublicMarketDataHistoryGetResponsesContentApplicationJsonSchemaDataItemsDetailsItemsGroupDetailsItems

- `dateTs` (string, optional) — Date of the file, Unix timestamp in milliseconds.
- `filename` (string, optional) — File name.
- `sizeMB` (string, optional) — File size in MB.
- `url` (string, optional) — Download URL for the file.

## Examples

**Response**

```json
{
  "code": "0",
  "msg": "",
  "data": [
    {
      "dateAggrType": "daily",
      "totalSizeMB": "15.64",
      "ts": "1756882260390",
      "details": [
        {
          "instId": "",
          "instFamily": "BTC-USDT",
          "instType": "SWAP",
          "dateRangeStart": "1756569600000",
          "dateRangeEnd": "1756656000000",
          "groupSizeMB": "15.64",
          "groupDetails": [
            {
              "dateTs": "1756656000000",
              "filename": "BTC-USDT-SWAP-trades-2025-09-01.zip",
              "sizeMB": "10.82",
              "url": "https://static.okx.com/cdn/okex/traderecords/trades/daily/20250901/BTC-USDT-SWAP-trades-2025-09-01.zip"
            },
            {
              "dateTs": "1756569600000",
              "filename": "BTC-USDT-SWAP-trades-2025-08-31.zip",
              "sizeMB": "4.82",
              "url": "https://static.okx.com/cdn/okex/traderecords/trades/daily/20250831/BTC-USDT-SWAP-trades-2025-08-31.zip"
            }
          ]
        }
      ]
    }
  ]
}
```

**SDK Code**

```python publicData_getMarketDataHistory_example
import requests

url = "https://www.okx.com/api/v5/public/market-data-history"

querystring = {"begin":"1701388800000","dateAggrType":"daily","end":"1701475200000","instType":"SPOT","module":"1"}

response = requests.get(url, params=querystring)

print(response.json())
```

```javascript publicData_getMarketDataHistory_example
const url = 'https://www.okx.com/api/v5/public/market-data-history?begin=1701388800000&dateAggrType=daily&end=1701475200000&instType=SPOT&module=1';
const options = {method: 'GET'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go publicData_getMarketDataHistory_example
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://www.okx.com/api/v5/public/market-data-history?begin=1701388800000&dateAggrType=daily&end=1701475200000&instType=SPOT&module=1"

	req, _ := http.NewRequest("GET", url, nil)

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby publicData_getMarketDataHistory_example
require 'uri'
require 'net/http'

url = URI("https://www.okx.com/api/v5/public/market-data-history?begin=1701388800000&dateAggrType=daily&end=1701475200000&instType=SPOT&module=1")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)

response = http.request(request)
puts response.read_body
```

```java publicData_getMarketDataHistory_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://www.okx.com/api/v5/public/market-data-history?begin=1701388800000&dateAggrType=daily&end=1701475200000&instType=SPOT&module=1")
  .asString();
```

```php publicData_getMarketDataHistory_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://www.okx.com/api/v5/public/market-data-history?begin=1701388800000&dateAggrType=daily&end=1701475200000&instType=SPOT&module=1');

echo $response->getBody();
```

```csharp publicData_getMarketDataHistory_example
using RestSharp;

var client = new RestClient("https://www.okx.com/api/v5/public/market-data-history?begin=1701388800000&dateAggrType=daily&end=1701475200000&instType=SPOT&module=1");
var request = new RestRequest(Method.GET);
IRestResponse response = client.Execute(request);
```

```swift publicData_getMarketDataHistory_example
import Foundation

let request = NSMutableURLRequest(url: NSURL(string: "https://www.okx.com/api/v5/public/market-data-history?begin=1701388800000&dateAggrType=daily&end=1701475200000&instType=SPOT&module=1")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```